/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package knapsack.algorithms;

import knapsack.Instance;
import knapsack.Solution;

/**
 *
 * @author yare
 */
public class BruteForce implements Algorithm {
    
    private static final String NAME = "Brute Force";
    
    public String getName(){
        return NAME;
    }
    
    private Solution solveBruteForce(Instance instance, Solution solution, int index) {
        
        if (index < 0) {
            return solution;
        }
        
        if (instance.items[index].weight > solution.remCapacity) {
            return solveBruteForce(instance, solution, index - 1);
        }
        
        Solution s1 = solution;
        Solution s2 = solution.clone();
        
        s2.value += instance.items[index].value;
        s2.remCapacity -= instance.items[index].weight;
        s2.taken[index] = 1;
        
        s1 = solveBruteForce(instance, s1, index - 1);
        s2 = solveBruteForce(instance, s2, index - 1);
        
        solution = s1.value < s2.value ? s2 : s1;
        return solution;
    }
    
    @Override
    public Solution run(Instance instance, Solution solution) {
        return solveBruteForce(instance, solution, instance.itemCount - 1);
    }
}
