/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package knapsack.algorithms;

import java.util.Arrays;
import knapsack.Instance;
import knapsack.ItemComparator;
import knapsack.Solution;

/**
 *
 * @author yare
 */
public class Heuristic implements Algorithm {
    
    private static final String NAME = "Heuristic";
    
    public String getName(){
        return NAME;
    }
    
    private Solution solveHeuristic(Instance instance) {
        Arrays.sort(instance.items, new ItemComparator());
        Solution solution = new Solution(instance.capacity, instance.itemCount);
        
        for (int index = instance.itemCount - 1; index >= 0; index--) {
            if (solution.remCapacity < instance.items[index].weight) {
                continue;
            }
            solution.value += instance.items[index].value;
            solution.remCapacity -= instance.items[index].weight;
            solution.taken[instance.items[index].seq] = 1;
        }
        return solution;
    }
    
    @Override
    public Solution run(Instance instance, Solution solution) {
        return solveHeuristic(instance);
    }
}
